@echo off
setlocal ENABLEDELAYEDEXPANSION

set DriveLetter=%1
set ExpectedDirs=2199
set ExpectedFiles=3237
set Dirs=
set Files=
set MisCount=
set LocFile=File(s)
set LocDir=Dir(s)
set CD=SQL Server 2012
set ExpectedVL=SQLFULL_ENU

if "%1"=="" goto usage

REM *** Verify that fciv.exe exists in the path
fciv -? >NUL
if NOT [%errorlevel%]==[0] goto usage

REM *** Verify there is a valid DVD in the drive
vol %1 > NUL
if NOT [%errorlevel%]==[0] goto usage

REM *** Check if license files available
if exist "%1\x86\DefaultSetup.ini" Set /a ExpectedFiles=%ExpectedFiles% + 1
if exist "%1\x64\DefaultSetup.ini" Set /a ExpectedFiles=%ExpectedFiles% + 1

REM *** Count directories and files
for /F "usebackq tokens=1 delims= " %%J in (`dir /s /A:D %DriveLetter%\ ^| findstr /c:"%LocDir%"`) do (set Dirs=%%J) 
for /F "usebackq tokens=1 delims= " %%J in (`dir /s /A-D %DriveLetter%\ ^| findstr /c:"%LocFile%"`) do (set Files=%%J) 

if NOT [%Dirs%]==[%ExpectedDirs%]   Set MisCount=Yes&echo *** The DVD in %1 contains %Dirs% directories instead of %ExpectedDirs% ***
if NOT [%Files%]==[%ExpectedFiles%] Set MisCount=Yes&echo *** The DVD in %1 contains %Files% files instead of %ExpectedFiles% ***
if [%MisCount%]==[Yes] goto end

echo The verification process may take several minutes...
echo The files on the DVD are being scanned to validate their integrity...
echo.

REM *** Run the integrity check
fciv -v %1\ -r -sha1 -bp %1\ -xml %ExpectedVL%.xml > integritycheck.log
findstr /c:"All files verified successfully" integritycheck.log
if NOT [%errorlevel%]==[0] (
   echo The integrity check could not validate all the files on the DVD.
   echo The integrity check log file is saved in the current directory.
   echo.
   goto end
) else (
   echo.
   echo The DVD in drive %1 is an authentic %CD%
   echo.
)

goto end

:usage
echo.
echo Usage: %~nx0 X:
echo.
echo   X:  DVD-ROM drive containing %CD%
echo.
echo   Fciv.exe must be in the current directory or in the path.
echo   You can download Fciv.exe from: 
echo   http://support.microsoft.com/default.aspx?scid=kb;en-us;841290
echo.

:end
endlocal